#ifndef _ANGORA_READER_H
#define _ANGORA_READER_H

#include <Angora/Structs.h>

#define ANGORA_SUB_OVERRIDE (1<<0)
#define ANGORA_SUB_TREE     (1<<1)
#define ANGORA_SUB_NEGATIVE (1<<2)

typedef struct _AngoraSubscription {
	char *path; /* node path of the subscription */
	int flags; /* bitwise OR of 0 or more of the flags given above */
} AngoraSubscription;

typdef AngoraSubscription *AngoraSubscriptionArray;

typedef struct _AngoraReaderCategory {
     char *path;
     char *description;
     char *contact_info;
     int flags;
} AngoraReaderCategory;

typedef struct _AngoraReaderMessage {
     ReaderCategory category;
     AngoraMessageId id;
     AngoraTimeStamp time;
     char *message;
} AngoraReaderMessage;

typedef struct _AngoraReaderState {
     char *path;
     AngoraTimeStamp timestamp;
} AngoraReaderState;

typedef AngoraReaderState *AngoraReaderStateArray;

typedef struct _AngoraReaderNode {
     char *path;
     int flags;
} AngoraReaderNode;

typedef struct _AngoraReaderClass {
     char *path;
     char *description;
} AngoraReaderClass;

/*
 * This is opaque for now because I haven't decided everything that
 * needs to be in it.  At the very least, the text of the message
 * needs to be in it; I'm not sure what else will need to be there, so
 * I'm leaving it unspecified for now.
 *
 * It may end up being opaque for good, since library routines to
 * display messages are already provided.  It may be desirable not to
 * let reader applications peek inside the messages, to force them to
 * use the provided routines for displaying them.  More thought will
 * have to be put into this, though, because it may actually be
 * necessary for reader applications to see inside the messages.
 */
typedef struct _AngoraReaderMessage AngoraReaderMessage;

#endif /* _ANGORA_READER_H */
