#ifndef _ANGORA_STRUCTS_H
#define _ANGORA_STRUCTS_H

/*
 * Defines for flags in Category structures
 */

#define ANGORA_CAT_TIMESTAMP (1<<0)

typedef struct _AngoraCategory {
     AngoraReaderCategory reader;
     AngoraProviderCategory provider;
} AngoraCategory;

typedef time_t AngoraTimeStamp;
typedef time_t AngoraMessageId;
typedef AngoraMessageId *AngoraMessageIdArray;

typedef struct _AngoraMessage {
     AngoraReaderMessage reader;
     AngoraProviderMessage provider;
} AngoraMessage;

/*
 * Defines for flags for Node structures
 */

#define ANGORA_NODE_CLASS    (1<<0)
#define ANGORA_NODE_CATEGORY (1<<1)

typedef struct _AngoraNode {
     AngoraReaderNode reader;
     AngoraProviderNode provider;
} AngoraNode;

typedef AngoraNode *AngoraNodeArray;

typedef struct _AngoraClass {
     AngoraReaderClass reader;
     AngoraProviderClass provider;
} AngoraClass;

typedef struct _AngoraMessageList {
     AngoraCategory category;
     AngoraMessageIdArray messages;
     int num_messages;
} AngoraMessageList;

typedef AngoraMessageList *AngoraMessageListArray;

#endif /* _ANGORA_STRUCTS_H */    
